<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "cpn_ehr".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CpnEhr".
 *
 * Columns in table "cpn_ehr" available as properties of the model,
 * followed by relations of table "cpn_ehr" available as properties of the model.
 *
 * @property integer $id
 * @property string $guid
 * @property string $name
 * @property string $logo_path
 * @property string $description
 * @property string $version
 * @property integer $mllp_flag
 * @property integer $keep_alive_flag
 * @property integer $save_responses_flag
 * @property integer $hl7_version_id
 * @property integer $sockets_flag
 * @property integer $folder_flag
 * @property integer $sftp_flag
 * @property integer $custom_flag
 * @property integer $enabled_flag
 * @property integer $del_flag
 * @property string $date_added
 * @property integer $added_by_account_id
 * @property string $date_updated
 * @property integer $updated_by_account_id
 *
 * @property Account $addedByAccount
 * @property CpnEhrInstallation[] $cpnEhrInstallations
 */
abstract class BaseCpnEhr extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'cpn_ehr';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CpnEhr|CpnEhrs', $n);
    }

    public static function representingColumn()
    {
        return 'guid';
    }

    public function rules()
    {
        return array(
            array('guid, name, added_by_account_id', 'required'),
            array('mllp_flag, keep_alive_flag, save_responses_flag, hl7_version_id, sockets_flag, folder_flag, sftp_flag, custom_flag, enabled_flag, del_flag, added_by_account_id, updated_by_account_id', 'numerical', 'integerOnly' => true),
            array('guid, logo_path', 'length', 'max' => 255),
            array('name, version', 'length', 'max' => 100),
            array('description, date_added, date_updated', 'safe'),
            array('logo_path, description, version, mllp_flag, keep_alive_flag, save_responses_flag, hl7_version_id, sockets_flag, folder_flag, sftp_flag, custom_flag, enabled_flag, del_flag, date_added, date_updated, updated_by_account_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, guid, name, logo_path, description, version, mllp_flag, keep_alive_flag, save_responses_flag, hl7_version_id, sockets_flag, folder_flag, sftp_flag, custom_flag, enabled_flag, del_flag, date_added, added_by_account_id, date_updated, updated_by_account_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'cpnEhrInstallations' => array(self::HAS_MANY, 'CpnEhrInstallation', 'cpn_ehr_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'guid' => Yii::t('app', 'Guid'),
            'name' => Yii::t('app', 'Name'),
            'logo_path' => Yii::t('app', 'Logo Path'),
            'description' => Yii::t('app', 'Description'),
            'version' => Yii::t('app', 'Version'),
            'mllp_flag' => Yii::t('app', 'Mllp Flag'),
            'keep_alive_flag' => Yii::t('app', 'Keep Alive Flag'),
            'save_responses_flag' => Yii::t('app', 'Save Responses Flag'),
            'hl7_version_id' => Yii::t('app', 'Hl7 Version'),
            'sockets_flag' => Yii::t('app', 'Sockets Flag'),
            'folder_flag' => Yii::t('app', 'Folder Flag'),
            'sftp_flag' => Yii::t('app', 'Sftp Flag'),
            'custom_flag' => Yii::t('app', 'Custom Flag'),
            'enabled_flag' => Yii::t('app', 'Enabled Flag'),
            'del_flag' => Yii::t('app', 'Del Flag'),
            'date_added' => Yii::t('app', 'Date Added'),
            'added_by_account_id' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'addedByAccount' => null,
            'cpnEhrInstallations' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('guid', $this->guid, true);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('logo_path', $this->logo_path, true);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('version', $this->version, true);
        $criteria->compare('mllp_flag', $this->mllp_flag);
        $criteria->compare('keep_alive_flag', $this->keep_alive_flag);
        $criteria->compare('save_responses_flag', $this->save_responses_flag);
        $criteria->compare('hl7_version_id', $this->hl7_version_id);
        $criteria->compare('sockets_flag', $this->sockets_flag);
        $criteria->compare('folder_flag', $this->folder_flag);
        $criteria->compare('sftp_flag', $this->sftp_flag);
        $criteria->compare('custom_flag', $this->custom_flag);
        $criteria->compare('enabled_flag', $this->enabled_flag);
        $criteria->compare('del_flag', $this->del_flag);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
